package ChatPon;

# 炶Plugin
# ChatPon.pm ver:1.02
#

use 5.006;
use strict;
use warnings;
use Socket;

require Exporter;

our @ISA = qw(Exporter);

our %EXPORT_TAGS = ( 'all' => [ qw(
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
);
use vars qw($revision $VERSION);

$revision = '$Id: ChatPon.pm,v 1.02 2004/07/09 21:30:00 lstein Exp $';
$VERSION='1.02';

our $DefaultClass = 'ChatPon';

our %clss = (
    MSG => 'SYS',
    GMM => 'GM',
    GVG => 'GM',
    WIS => 'WIS',
    GLD => 'GLD',
    PTY => 'PT',
    PTY => 'PT',
    OPN => 'OPN',
    OPN_ => 'MY',
    CHR => 'OPN',
    CHR_ => 'MY'
);

sub new {
    my ($class) = @_;
    shift if ($class && $class eq $DefaultClass);
    my $self = {
        class => \%clss
    };
    bless $self,$DefaultClass;
}

# &dayfile(YYYY,MM,DD,dir,chara,server)
# t@CʒuԂ
sub dayfile {
    my ($pkg, $year, $month, $day, $dir, $chara, $server) = arg_check(@_);
    
    my $path = sprintf("$dir/%d%02d%02d.txt",$year,$month,$day);
    return wantarray ? ($path, $chara) : $path;
}

# linesplit(line)
# ÖsAʁAԁAf[^ɐ؂蕪
sub linesplit {
    my ($pkg, $line) = arg_check(@_);
    my ($tcls, $class);
    if ($line) {
        $line =~ /^.(\w+)(.)\t<?(\d+:\d+:\d+)?>?\s(.+)/;
        if ($2 eq ')') {
           $tcls = "$1_";
        } else {
           $tcls = $1;
        }
        if ($tcls) {
            $class = $clss{$tcls};
        } else {
            $class = '___';
        }
        return ($class, $3, $4);
    } else {
        return undef;
    }
}

# sys_decompose(dat)
# VXeO̔F
sub sys_decompose {
    my ($pkg, $dat) = arg_check(@_);
    if ($dat =~ /^(.+?)\[(.+?)\/(.+?)\]ŃOC$/) {
        return wantarray ? ('login', $1) : 'login';
    } elsif ($dat =~ /^(.+?)\[(.+?)\/(.+?)\]ŃOAEg$/) {
        return wantarray ? ('logout', $1) : 'logout';
    }
}

# wis_decompose(dat)
# wis̕
sub wis_decompose {
    my ($pkg, $dat) = arg_check(@_);
    $dat =~ /^(.+?)\s:\s(.+)/;
    return ("(From $1)", $2);
}

# opn_decompose(dat)
# ʏb̕
sub opn_decompose {
    my ($pkg, $dat) = arg_check(@_);
    $dat =~ /^(.+?)\s:\s(.+)/;
    return ($1, $2);
}

sub arg_check {
    return @_ if defined($_[0]) && (!ref($_[0])) &&($_[0] eq $DefaultClass);
    our ($cls);
    unless (defined($_[0]) && (ref($_[0]) eq $DefaultClass || UNIVERSAL::isa($_[0],$DefaultClass))) {
        $cls = $DefaultClass->new() unless defined($cls);
        unshift(@_, $cls);
    }
    return wantarray ? @_ : $cls;
}

1;
